;
;   DESKTOP CONTEXT MENU
;   written by Ivan Poddubny
;
;    -  
;   e-mail: ivan-yar@bk.ru
;
;   Compile with flat assembler
;

include 'macros.inc'

meos_app_start
code

  mov    [start_info.mode], 16
  mov    [start_info.params], 0
  mov    [start_info.workarea], work_area

  mov    eax,40         ;   
  mov    ebx,100000b  ;    
  int    0x40

still:             ;    

  mov    eax,10         ;  
  int    0x40

  cmp    eax,6         ; ?
  jne    still

  mov    eax,37         ;   ?
  mov    ebx,2
  int    0x40

  cmp    eax,2         ;   , 
  jne    still

;---!---

;  mov   eax,37       ;    -     (0;0), 
;  xor   ebx,ebx
;  int   0x40
;  test  eax,eax      ;    (0;0), .. eax = 0
;  je    exit


  mov    eax,9         ;     
  mov    ebx,procinfo
  xor    ecx,ecx
  int    0x40

  inc    eax         ;   eax    + 1
  mov    [processes],eax
  mov    ecx,1

 new_process:
  pushad
  mov    eax,9         ;    ;  -  ecx
  mov    ebx,procinfo
  int    0x40
  mov    eax,37         ;  
  xor    ebx,ebx
  int    0x40
  mov    ebx,eax          ; eax = cursor_x
  shr    eax,16             ; ebx = cursor_y
  and    ebx,0xffff
  mov    [curx1],eax         ; curx1 = cursor_x
  mov    [cury1],ebx         ; cury1 = cursor_y
  mov    eax,[procinfo.x_start]     ; eax = wnd_x_start
  mov    ebx,[procinfo.y_start]     ; ebx = wnd_y_start

  mov    ecx,[procinfo.x_size]
  add    ecx,eax          ; ecx = wnd_x_end
  mov    edx,[procinfo.y_size]
  add    edx,ebx          ; ecx = wnd_y_end

  cmp    eax,[curx1]  ; wnd_x_start > cursor_x =>   
  jg    ne_goden
  cmp    ecx,[curx1]  ; wnd_x_end   < cursor_x =>   
  jl    ne_goden
  cmp    ebx,[cury1]  ; wnd_y_start > cursor_y =>   
  jg    ne_goden
  cmp    edx,[cury1]  ; wnd_y_end   < cursor_y =>   
  jl    ne_goden

goden:             ;    - ,    
  popad
  jmp    still

ne_goden:         ;     , 
  popad
  inc    ecx
  cmp    ecx,[processes]
  jl    new_process  ;    ,   


@@:        ; ,       
  mov    eax,37
  mov    ebx,2    ;  37-2:
  int    0x40    ;      ?
  cmp    eax,ebx ;  , (eax != 2)
  jnz    @f    ;       

  mov    eax,5    ; 
  mov    ebx,2    ;    2 
  int    0x40

  jmp    @b    ;      
@@:

;     ,  ,   :
@@:
  cmp    [menu_opened],0
  je    @f
  mov    eax,5
  mov    ebx,3  ;  3 
  int    0x40
  jmp    @b
@@:

  mov    eax,51         ;       () 
  mov    ebx,1         ;   (thread)
  mov    ecx,start_wnd     ;   
  mov    edx,stack_wnd     ;    
  int    0x40

  jmp    still



exit_menu:          ;    ,    [menu_opened] 0
  mov    [menu_opened],0
exit:              ;   ,     
  or    eax,-1          ; eax = -1
  int    0x40




;    
start_wnd:
  mov    [menu_opened],1
  call    draw_window

  mov    eax,40        ;       
  mov    ebx,100101b ;  +  + 
  int    0x40

still2:         ;    

  mov    eax,10        ;  
  int    0x40

  cmp    eax,1        ; ?
  je    red
  cmp    eax,3        ; ?
  je    button
  cmp    eax,6        ; ?
  je    mouse

  jmp    still2        ;     


;  
mouse:          ;     , 
  mov    eax,37
  mov    ebx,2      ;   ?
  int    0x40
  test    eax,eax   ; ? -  !    
  jz    still2
  jmp    exit_menu ;   -  -  


;  
red:
  call    draw_window
  jmp    still2


;  
button:
  mov    eax,17          ;    
  int    0x40

  cmp    ah,10          ;   10
  jl    nofuncbtns    ;   -  

  add    ah,-10          ;     10
  movzx ebx,ah          ;       ebx
  lea    esi, [startapps + ebx*4]
  lea    edi, [start_info.path]
  mov    esi, [esi]
  cld
 @@:
  lodsb
  stosb
  test    al, al
  jnz    @b
  mcall 58, start_info

;  mov   eax,5         ; ,   
;  mov   ebx,1         ;        (  ???)
;  int   0x40          ;   ,    
               ;  

nofuncbtns:          ;  
  jmp    exit_menu



_BTNS_          = 8      ;   (" ")

if lang eq ru
  font          = 0x00000000
  string_length   = 20        ;  
  wnd_x_size      = 133     ;  
  header_pos      = 36 shl 16 + 7
else
  font          = 0x10000000
  string_length   = 12        ;  
  wnd_x_size      = 105     ;  
  header_pos      = 23 shl 16 + 7
end if

;*******************************
;********     ********
;*******************************

draw_window:

  mov    eax,12         ;  ""
  mov    ebx,1
  int    0x40

  mov    eax,[curx1]     ;   
  mov    [curx],eax     ;    
  mov    eax,[cury1]
  mov    [cury],eax

;     ,       
  mov    eax,14              ;   
  int    0x40
  mov    ebx,eax
  shr    eax,16              ;  eax - x_screen
  and    ebx,0xffff          ;  ebx - y_screen
  add    eax,-wnd_x_size       ; eax = [x_screen -  ]
  add    ebx,-_BTNS_*15-21     ; ebx = [y_screen -  ]

  cmp    eax,[curx]
  jg    .okx              ;       ,
  add    [curx],-wnd_x_size    ;     100
 .okx:

  cmp    ebx, [cury]
  jg    .oky              ;    
  add    [cury], -_BTNS_*15-21
 .oky:

  mov    eax, 48           ;   
  mov    ebx, 3
  mov    ecx, sc           ;   
  mov    edx, sizeof.system_colors ;    
  int    0x40

  xor    eax, eax       ;  0 -  
  mov    ebx, [curx]       ;  ebx = [  x] shl 16 + []
  shl    ebx, 16
  add    ebx, wnd_x_size
  mov    ecx, [cury]       ;  ecx = [  y] shl 16 + []
  shl    ecx, 16
  add    ecx, _BTNS_*15+21
  mov    edx, [sc.work]       ;    
  mov    esi, [sc.grab]       ;   
  or    esi, 0x81000000
  mov    edi, [sc.frame]    ;   
  int    0x40

  mov    eax, 4           ; 
  mov    ebx, header_pos    ;  [x] shl 16 + [y]
  mov    ecx, [sc.grab_text];     ()
  add    ecx, -0x333333
  or    ecx, 0x10000000
  mov    edx, header       ;   
  mov    esi, header.size   ;    ("M E N U")
  int    0x40
  add    ecx, 0x333333       ;   
  add    ebx, 1 shl 16       ;     1
  int    0x40

  mov    ebx, 1*65536+wnd_x_size-2  ;   
  mov    ecx, 20*65536+15
  mov    edx, 10 or 0x40000000 ;  30  =>   

  mov    edi,_BTNS_         ;   ()

 newbtn:             ;  
  mov    eax,8             ;   
  int    0x40

                 ;     
  pushad             ;    
  shr    ecx, 16
  and    ebx, 0xffff0000
  add    ebx, ecx         ;   ebx = [x] shl 16 + [y];
  add    ebx, 10*65536+4      ;   ebx +=    ;
  mov    ecx, [sc.work_text]  ;     
  or    ecx, font
  add    edx, -10         ;   edx =  ;
  imul    edx, string_length   ;   edx *=  ;
  add    edx, text         ;   edx += text;    edx  
  mov    esi, string_length   ;    esi -  
  mov    eax, 4             ;    4 -  
  int    0x40
  popad

  inc    edx             ;   ++;
  add    ecx,15*65536         ;     y
  dec    edi             ;   
  jnz    newbtn             ;   ,    

  mov    eax,12             ;  ""
  mov    ebx,2
  int    0x40

ret                 ; 



;  
DATA

  macro strtbl name, [string]
  {
   common
     label name dword
   forward
     local str
     dd str
   forward
     str db string
  }

  strtbl startapps     ,\
    <"/RD/1/PIC4",0>     ,\
    <"/RD/1/DESKTOP",0>  ,\
    <"/RD/1/MV",0>     ,\
    <"/RD/1/JPEGVIEW",0> ,\
    <"/RD/1/CPU",0>     ,\
    <"/RD/1/SPANEL",0>     ,\
    <"/RD/1/ICON2",0>     ,\
    <"/RD/1/VRR",0>

;  header:            ; 
;    db 'M E N U'
;  header_len = $ - header

;  text:              ;   
;    db 'Background  '; 12
;    db 'Colors      '
;    db 'MeView      '
;    db 'Processes   '
;    db 'Panel setup '
;    db 'Icon manager'

  sz header, "KolibriOS"
 
  lsz text,\
    en, 'Background  ',\
    en, 'Colors      ',\
    en, 'MeView      ',\
    en, 'JpegView    ',\
    en, 'Processes   ',\
    en, 'Panel setup ',\
    en, 'Icon manager',\
    en, 'VRR         ',\
    \
    ru, '      ',\
    ru, '      ',\
    ru, ' BMP        ',\
    ru, ' JPEG       ',\
    ru, '            ',\
    ru, '     ',\
    ru, '  ',\
    ru, '   ',\



;  
UDATA
  processes   dd ?        ;    
  curx1       dd ?        ;  
  cury1       dd ?
  curx          dd ?        ;   
  cury          dd ?

  menu_opened db ?        ;    ? (1-, 0-)

  align 32
  start_info:
    .mode     dd ?
         dd ?
    .params     dd ?
         dd ?
    .workarea     dd ?
    .path:
      rb 256


  sc       system_colors    ;  
  procinfo process_information    ;   

  work_area:
    rb 0x1000

  rb 1024            ;     -   1 
  align 32
  stack_wnd:


MEOS_APP_END
;  
