;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;                                              ;
;   SYSTEM X-TREE BROWSER                      ;
;                                              ;
;   Author: Pavlushin Evgeni waptap@mail.ru    ;
;   Test version!         www.deck4.narod.ru   ;
;   Compile with FASM for MenuetOS             ;
;                                              ;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

; 47 version
; Navigation is work! Image buttons! Clipboard copy interface!
; Copy is work with COPYR! Head Menu is work!
; New quick algrythm for sorting files!
; New sort algorythms by extension, size, date!
; Filebrowser & save/open dialog in one programm
; Prompt line edit F11 (use keys, blackspce, enter)
; Helpscr, update menu, delete from ramdisk
; 1000000 Kb memory!

;******************************************************************************
  use32
  org    0x0
  db     'MENUET01'   ; 8 byte id
  dd     0x01         ; header version
  dd     START        ; program start
  dd     I_END        ; program image size
  dd     1000000      ; memory
  dd     1000000      ; stack
  dd     clipfile ,0x0   ; param,icon
;  dd 0,0

;******************************************************************************
include 'macros.inc'
include 'ascl.inc'
include 'ascgl.inc'

START:                          ; start of execution
    mov eax,40
    mov ebx,0100111b
    int 0x40

    cmp byte [clipfile],0 ;test parameters line
    jne no_brow           ;it's dialog
    mov [browser],dword 1 ;it's browser
no_brow:

    convbmp but_file,tsoi
    bmptoimg but_file,tsoi,tempimg
    getimg tempimg,0,0,286,16,butimg
    getimg tempimg,288,0,60,16,logoimg

    call read_directory
    call convertation
red:
    call draw_window            ; at first, draw the window

still:
    wtevent red,key,button

scrolltest:
    mov eax,37
    mov ebx,2
    int 0x40
    cmp eax,1
    jne still

scrl:
    mov eax,37
    mov ebx,1
    int 0x40
    mov ebx,eax
    shr eax,16       ;x
    and ebx,0xffff   ;y

    cmp [browser],0
    je  scrl_dlg

    sub ebx,76;-2 ;2
    mov ebp,ebx
    mov esi,[procinfo.y_size]
    sub esi,90;-2
    cmp ebx,esi

    ja still
    sub eax,350
    cmp eax,6
    ja still
    mov [mousey],ebp
    mov [filecursor],ebx

    jmp red

scrl_dlg:
    sub ebx,54
    mov ebp,ebx
    mov esi,[procinfo.y_size]
    sub esi,86
    cmp ebx,esi

    ja still
    sub eax,296
    cmp eax,6
    ja still
    mov [mousey],ebp
    mov [filecursor],ebx

    jmp red


;===================
; Test keyboard
;===================
key:                          ; key
    mov  eax,2
    int  0x40
    cmp dword [focus],0
    jne con_edit
    cmp  ah,key_Up
    jne  no_upk
    mov  ebx,1
    jmp  up
no_upk:
    cmp  ah,key_Down
    jne  no_downk
    mov  ebx,1
    jmp  down
no_downk:
    cmp  ah,key_PgUp
    jne  no_pgup
    mov  ebx,10
    jmp  up
no_pgup:
    cmp  ah,key_PgDown
    jne  no_pgdown
    mov  ebx,10
    jmp  down
no_pgdown:
    cmp  ah,key_Enter
    jne  no_ent
    mov [mousey],0
    jmp filexadd
no_ent:
    cmp  ah,key_Bspace
    je   back
    cmp  ah,key_F3
    je   textopen
    cmp  ah,key_F2
    je   viewset
    cmp  ah,key_F12
    je   update
    cmp  ah,key_F5
    je   copy_to_clip
    cmp  ah,key_F6
    je   paste_from_clip
    cmp  ah,key_F11
    jne  no_coninput
    not  [focus]
    jmp  red
no_coninput:
    jmp still

; test input string
con_edit:
    cmp  ah,key_Enter
    jne  no_con_ent
    not  [focus]
    jmp  update
no_con_ent:
    cmp  ah,key_Left
    jne  no_con_left
    dec  [cursor]
    jmp  red
no_con_left:
    cmp  ah,key_Right
    jne  no_con_right
    inc  [cursor]
    jmp  red
no_con_right:
    cmp  ah,key_Bspace
    jne  no_con_bspace

    mov ecx,[cursor]
    cmp ecx,0
    je  still
    dec ecx
    mov  ebp,[cursor]
lobsp:
    mov  bl,byte [path+ebp]
    mov  byte [path+ebp-1],bl
    inc  ebp
    cmp  ebp,100
    jne  lobsp
    dec  [cursor]
    jmp  red
no_con_bspace:

    mov ecx,[cursor]
    dec ecx
    mov  ebp,100 ;[cursor]
losx:
    mov  bl,byte [path+ebp]
    mov  byte [path+ebp+1],bl
    dec  ebp
    cmp  ebp,ecx ;100
    jne  losx

    mov  ebp, [cursor]
    cmp  ebp,100
    ja   still

    mov  byte [path+ebp],ah
    inc  dword [cursor]
    jmp  red

;----------------------------
;Test on mouse button
;-----------------------------

  button:                       ; button
    mov  eax,17
    int  0x40

    cmp ah,4
    jne no_filelist

mousetest:
    mov eax,37
    mov ebx,1
    int 0x40
    mov ebx,eax
    shr eax,16       ;x
    and ebx,0xffff   ;y

    cmp [browser],0
    je  no_brow3

    sub ebx,80
    mov [mousey],ebx
    cmp ebx,10*50
    ja still
    sub eax,50
    cmp eax,300-20
    ja still
    jmp file_add

no_brow3:
    sub ebx,56
    mov [mousey],ebx
    cmp ebx,10*50
    ja still
    sub eax,16
    cmp eax,270-20
    ja still

filexadd:
file_add:
    mov  esi,0
lll2:
    mov al,byte [path+esi]
    cmp al,byte 0 ;' '; '/'
    je  fis2
    cmp al,byte ' '; '/'
    je  fis2
    inc esi
    cmp esi,100
    jna lll2
    jmp fis2

fis2:
    mov edx,0  ;for div correct work div
    mov eax,dword [mousey]
    mov ebx,10
    div ebx

    add eax,[filecursor]
    mov ebx,62
    mul ebx
    mov edi,eax
    cmp [convinfo+edi+26],dword 'FOL '
    jne openf
    mov [path+esi],byte '/'
    inc esi
    mov ebp,8
los:
    mov al,[convinfo+edi]
    mov [path+esi],al
    inc esi
    inc edi
    dec ebp
    jnz los

    mov [filecursor],0
    call read_directory
    call convertation
    call draw_window
    jmp still

openf:
    mov ecx,100
lopt:
    mov al,[path+ecx]
    mov [paramtest+ecx],al
    dec ecx
    jns lopt

    mov [paramtest+esi],byte '/'
    inc esi
    mov ebp,8+4
    mov edx,edi
losf:
    mov al,[convinfo+edi]
    mov [paramtest+esi],al
    inc esi
    inc edi
    dec ebp
    jnz losf

    cmp [browser],0
    jne is_brow
    mov ebx,clipfile
    mov ecx,paramtest
    mov edx,100
    mov esi,0
    mov eax,33
    int 0x40
    jmp exit
is_brow:

    mov eax,dword [convinfo+edx+8]
    cmp eax,'.   '
    jne noexecute
    mov ebx,0
    jmp execute
noexecute:

    cmp eax,'.JPG'
    jne nojv
    mov ebx,jpgview
    jmp run
nojv:
    cmp eax,'.BMP'
    jne nobv
    mov ebx,bmpview
    jmp run
nobv:
    cmp eax,'.ASM'
    je edit
    cmp eax,'.TXT'
    je edit
    cmp eax,'.INC'
    je edit
    jmp still
edit:
    mov ebx,editor
    jmp run

execute:
    mov ecx,120 ;200
loexe:
    mov al,[paramtest+ecx]
    cmp al,' '
    je  badl
    cmp al,'.'
    je  badl
    jmp okl
badl:
    mov al,0
okl:
    mov [open_path+ecx],al
    dec ecx
    jns loexe


    mov eax,58
    mov ebx,fileinfo_start
    int 0x40

run:
    mov ecx,paramtest
    mov eax,19
    int 0x40
    jmp still

no_filelist:

    cmp ah,8
    jne no_update
update:
    call read_directory
    call convertation
;    mov [filecursor],0
    call draw_window
no_update:

    cmp ah,9
    jne no_textopen
textopen:
    mov  esi,0
xlll2:
    mov al,byte [path+esi]
    cmp al,byte '/'
    jne  xfis2
    inc esi
    cmp esi,12*20
    jnae xlll2
    jmp still
xfis2:
    mov al,byte [path+esi]
    cmp al,byte ' '
    je  xaa2
    inc esi
    cmp esi,12*20
    jnae xfis2
    jmp still
xaa2:
    mov eax,[filecursor]
    mov ebx,62
    mul ebx
    mov edi,eax
    cmp [convinfo+edi+26],dword 'FOL '
    je  still
    mov ecx,12*20
xlopt:
    mov al,[path+ecx]
    mov [paramtest+ecx],al
    dec ecx
    jns xlopt
    mov [paramtest+esi],byte '/'
    inc esi
    mov ebp,8+4
    mov edx,edi
xlosf:
    mov al,[convinfo+edi]
    mov [paramtest+esi],al
    inc esi
    inc edi
    dec ebp
    jnz xlosf
    mov [paramtest+esi],byte 0
    mov ebx,editor
    mov ecx,paramtest
    mov eax,19
    int 0x40
    jmp still

no_textopen:

    cmp  ah,11
    jne  no_view
viewset:
;    not  dword [delflag]
    inc dword [viewmode]
    cmp dword [viewmode],8
    jnae not_cm
    mov [viewmode],0
not_cm:
    call read_directory
    call convertation
    mov [filecursor],0
    call draw_window
    jmp still
no_view:

    cmp  ah,12        ;move back
    jne  no_back
back:
    mov  esi,12*20
lll:
    mov al,byte [path+esi]
    cmp al,byte ' '
    jne  findsl
    dec esi
    jnz lll
    jmp still
findsl:
    dec esi
fis:
    mov al,byte [path+esi]
    cmp al,byte '/'
    je  aa
    mov [path+esi],byte ' '
    dec esi
    jnz fis
aa:
    mov [path+esi],byte ' '

    mov [filecursor],0
    call read_directory
    call convertation
    call draw_window
    jmp still

no_back:
    cmp  ah,13        ;string up?
    jne  no_up
    mov  ebx,1        ;step
up:
    mov  [downstop],0
    sub  [filecursor],ebx
    cmp  [filecursor],0
    jnl  cr_ok
    mov  [filecursor],0
cr_ok:
    jmp  draw_wd
no_up:
    cmp  ah,14       ;string down?
    jne  no_dn
    mov  ebx,1       ;step
down:
    cmp [downstop],1
    je  no_dn
    add [filecursor],ebx
    jmp draw_wd
no_dn:

    cmp  ah,15
    jne  no_copyclip    ;copy to clipboard
copy_to_clip:
    mov  ebx,clipfile
    mov  eax,32
    int  0x40
    mov  esi,0
wlll2:
    mov al,byte [path+esi]
    cmp al,byte '/'
    jne wfis2
    inc esi
    cmp esi,12*20
    jnae wlll2
    jmp still
wfis2:
    mov al,byte [path+esi]
    cmp al,byte ' '
    je  waa2
    inc esi
    cmp esi,12*20
    jnae wfis2
    jmp still
waa2:
    mov eax,[filecursor]
    mov ebx,62
    mul ebx
    mov edi,eax
    cmp [convinfo+edi+26],dword 'FOL '
    je  still
    mov ecx,12*20
wlopt:
    mov al,[path+ecx]
    mov [paramtest+ecx],al
    dec ecx
    jns wlopt
    mov [paramtest+esi],byte '/'
    inc esi
    mov ebp,8+4
    mov edx,edi
wlosf:
    mov al,[convinfo+edi]
    mov [paramtest+esi],al
    inc esi
    inc edi
    dec ebp
    jnz wlosf
    mov [paramtest+esi],byte 0
    mov ebx,clipfile
    mov ecx,paramtest
    mov edx,100
    mov esi,0
    mov eax,33
    int 0x40
    jmp still
no_copyclip:

    cmp ah,16
    jne no_clippaste
paste_from_clip:
    mov ebx,clipfile
    mov ecx,0
    mov edx,-1
    mov esi,sourcepath
    mov eax,6
    int 0x40

    mov ecx,99
cdestp:
    mov al,[path+ecx]
    mov [destpath+ecx],al
    dec ecx
    jns cdestp

    mov esi,0
zlll2:
    mov al,byte [destpath+esi]
    cmp al,byte '/'
    jne zfis2
    inc esi
    cmp esi,100
    jnae zlll2
    jmp still
zfis2:
    mov al,byte [destpath+esi]
    cmp al,byte ' '
    je  zaa2
    inc esi
    cmp esi,100
    jnae zfis2
    jmp still
zaa2:
    mov byte [destpath+esi],'/'
    inc esi

    mov edi,0
qlll2:
    mov al,byte [sourcepath+edi]
    cmp al,byte '.'
    je  qfis2
    inc edi
    cmp edi,100
    jnae qlll2
    jmp still
qfis2:
    sub edi,8  ;.-8=start of file name

    mov ecx,11 ;11 sybols
cfname:
    mov al,[sourcepath+edi]
    cmp al,byte ' '
    je  dar
    mov [destpath+esi],al
    inc esi
dar:
    inc edi
    dec ecx
    jns cfname

;    mov [destpath+esi],byte 0

    mov ecx,199
cdestjp:
    mov al,[sourcepath+ecx]
    cmp al,byte 0
    jne nor
    mov al,byte 32
nor:
    mov [sourcepath+ecx],al
    dec ecx
    jns cdestjp

    mov  eax,4                     ; function 4 : write text to window
    mov  ebx,10*65536+67             ; [x start] *65536 + [y start]
    mov  ecx,0x00000000 ;[sc.grab_text] ; color of text RRGGBB
    mov  edx,sourcepath                  ; pointer to text beginning
    mov  esi,100 ;12*20             ; text length
    int  0x40
    mov  ebx,250*65536+67             ; [x start] *65536 + [y start]
    mov  ecx,0x00000000 ;[sc.grab_text] ; color of text RRGGBB
    mov  edx,destpath                  ; pointer to text beginning
    mov  esi,100 ;12*20             ; text length
    int  0x40

    mov ebx,copyrfile
    mov ecx,sourcepath
    mov eax,19
    int 0x40
    jmp still
no_clippaste:

    cmp ah,19         ;Delete from floppy
    jne no_delt
    cmp dword [path],'/RD/'
    jne no_delt
    cmp byte [path+4],'1'
    jne no_delt

    mov eax,[filecursor]
    mov ebx,62
    mul ebx
    mov edi,eax
    add edi,convinfo
    mov ebp,edi
    mov eax,dword [edi]
    mov dword [paramtest],eax
    mov eax,dword [edi+4]
    mov dword [paramtest+4],eax
    mov eax,dword [edi+4+4+1]
    mov dword [paramtest+4+4],eax

    mov ebx,paramtest
    mov eax,32
    int 0x40
    jmp update
no_delt:

    cmp ah,20         ;I - Help
    je  help_scr

    cmp ah,22
    jne no_headfile
    mov [drawhf],1
    call draw_window
    mov [drawhf],0
    jmp still
no_headfile:

    cmp ah,23
    jne no_headview
    mov [drawhv],1
    call draw_window
    mov [drawhv],0
    jmp still
no_headview:

    cmp ah,24
    jne no_headinfo
    mov [drawhi],1
    call draw_window
    mov [drawhi],0
    jmp still
no_headinfo:

;FILE MENU
    cmp ah,30
    jne no_file_open
    mov [mousey],0
    jmp filexadd
no_file_open:

    cmp ah,31
    je  copy_to_clip    ;Copy

    cmp ah,32
    je  paste_from_clip ;Paste

    cmp ah,37
    jne no_file_exit
    jmp exit
no_file_exit:

;VIEW MENU
    cmp ah,40         ;Sort by name show del
    jne no_sn
    mov dword [viewmode],0
    jmp update
no_sn:

    cmp ah,41         ;Sort by extension show del
    jne no_se
    mov dword [viewmode],1
    jmp update
no_se:

    cmp ah,42         ;Sort by size show del
    jne no_ss
    mov dword [viewmode],2
    jmp update
no_ss:

    cmp ah,43         ;Sort by date show del
    jne no_sd
    mov dword [viewmode],3
    jmp update
no_sd:

    cmp ah,44         ;Show del files
    jne no_ds
    or  dword [viewmode],0100b
    jmp update
no_ds:

    cmp ah,45         ;Fade del files
    jne no_df
    and  dword [viewmode],0100b
    jmp update
no_df:

;HELP MENU
    cmp ah,50         ;Help?
    je  help_scr


    cmp  ah,1                   ; test on exit button
    jne  still

    cmp [browser],0
    jne exit
    mov ebx,clipfile      ;Eslo dialog zakrit daem ob etom znat proge
    mov eax,32
    int 0x40

exit:
    mov eax,-1
    int 0x40

draw_wd:
    call draw_window
    jmp still


draw_window:
    cmp [browser],dword 1
    je  draw_browser_window
    jmp draw_dialog_window

help_scr:
    mov eax,[procinfo.y_size]
    sub eax,90
    drawfbox 40,76,300,eax,0x00000000
    mov eax,[procinfo.y_size]
    sub eax,92
    drawfbox 41,77,298,eax,0x00ffffff
    mov edi,14
    mov ebx,(41+26)*65536+(77+20)
    mov ecx,cl_Black
    mov edx,help_text

    mov eax,4
    mov esi,40
helploo:
    int 0x40
    add ebx,11
    add edx,40
    dec edi
    jnz helploo
    jmp still

;HELP TEXT
help_text:
       ;0123456789012345678901234567890123456789
    db '      ~~~~~ SYSTEM X-TREE ~~~~~         '
    db '                 HELP                   '
    db '                                        '
    db 'F2 - CHANGE SORTMODE (name,ext,size,dat)'
    db 'F3 - VIEW file in notepad               '

    db 'F5 - COPY FILE to clipboard             '
    db 'F6 - PASTE FILE from clipboard          '
    db 'F11- EDIT PROMPT string                 '
    db 'F12- UPDATE directory sources           '
    db '                                        '

    db 'Navigation:                             '
    db 'Enter - input to directory              '
    db 'Backspace - back to previos directory   '
    db 'PageDn/PageUp, Up/Down - move cursor    '


;   *********************************************
;   *******  WINDOW DEFINITIONS AND DRAW ********
;   ************** FILE BROWSER *****************

draw_browser_window:
    mov  eax,48
    mov  ebx,3
    mov  ecx,sc
    mov  edx,sizeof.system_colors
    int  0x40

    mov  eax,[sc.work_button]
    mov  [b_color],eax

    mov  eax,12                    ; function 12:tell os about windowdraw
    mov  ebx,1                     ; 1, start of draw
    int  0x40

;Window

    xor  eax,eax                   ; function 0 : define and draw window
    mov  ebx,140*65536+400         ; [x start] *65536 + [x size]
    mov  ecx,160*65536+280         ; [y start] *65536 + [y size]
;    mov  edx,[sc.work]             ; color of work area RRGGBB
    or   edx,0x03ffffff;000000
    int  0x40

;Get proc info
    mov eax,9
    mov ebx,procinfo
    mov ecx,-1
    int 0x40

    mov  eax,[sc.grab_text]        ; color of text RRGGBB
    or   eax,0x10000000
    label 8,8,'SYSTEM X-TREE FILE BROWSER',eax

;Draw buttons headers
    mov  eax,8
    mov  ebx,8*65536+(6*8-1) ;start pos x
    mov  ecx,23*65536+10      ;start pos y
    mov  edx,22;+1000000000000000000000000000000b  ;spoke butt
    mov  edi,3                ;draw 13 button's
    mov  esi,0x006699aa
    int  0x40
    dec edi
nexthbut:
    add  ebx,(6*8)*65536
    inc  edx
    int  0x40
    dec  edi
    jnz  nexthbut

;File STRING
    label 8,25,'  FILE    VIEW    INFO  ',cl_White ;Black

;BlackLine
    mov eax,[procinfo.x_size]
    sub eax,10
    drawfbox 5,35, eax, 1, cl_Black

;Draw head->file buttons
    cmp [drawhf],1
    jne  no_drawhf
    mov  ebx,8*65536+6*12 ;start pos x
    mov  ecx,35*65536+10      ;start pos y
    mov  edx,30  ;spoke butt
    mov  edi,8                ;draw 4 button's
    mov  esi,cl_Grey
    call menubutton
no_drawhf:

;Draw head->view buttons
    cmp [drawhv],1
    jne  no_drawhv
    mov  ebx,(8+6*8)*65536+6*12 ;start pos x
    mov  ecx,35*65536+10      ;start pos y
    mov  edx,40  ;spoke butt
    mov  edi,6                ;draw 4 button's
    mov  esi,cl_Grey
    call menubutton
no_drawhv:

;Draw head->info buttons
    cmp [drawhi],1
    jne  no_drawhi
    mov  ebx,(8+12*8)*65536+6*12 ;start pos x
    mov  ecx,35*65536+10      ;start pos y
    mov  edx,50  ;spoke butt
    mov  edi,2                ;draw 2 button's
    mov  esi,cl_Grey
    call menubutton
no_drawhi:

;Draw buttons instruments
    mov  eax,8
    mov  ebx,10*65536+16+5 ;start pos x
    mov  ecx,37*65536+15      ;start pos y
    mov  edx,8;+1000000000000000000000000000000b  ;spoke butt
    mov  edi,13                ;draw 13 button's
    mov  esi,cl_Grey
    int  0x40
    dec edi
nextbut:
    add  ebx,(16+6)*65536
    inc  edx
    int  0x40
    dec  edi
    jnz  nextbut

;But img
    setimg 10,37,butimg
;left logo
    add eax,[procinfo.x_size]
    sub eax,80
    mov [temp],eax
    setimg [temp],37,logoimg

;Draw URL String
    mov eax,[procinfo.x_size]
    sub eax,60
    drawfbox 50,54,eax,12,cl_Black
    mov eax,[procinfo.x_size]
    sub eax,62
    drawfbox 51,55,eax,10,cl_White

    label 26,56,"URL:",cl_Black

    mov  eax,4                     ; function 4 : write text to window
    mov  ebx,52*65536+56             ; [x start] *65536 + [y start]
    mov  ecx,0x00000000 ;[sc.grab_text] ; color of text RRGGBB
    mov  edx,path                  ; pointer to text beginning
    mov  esi,40 ;12*20             ; text length
    int  0x40

;view mode
;    outcount [viewmode],284,25,cl_Black,1*65536

;Out view mode info
    mov eax,[viewmode]
    mov ebx,16
    mul ebx
    mov edx,eax
    mov eax,4
    mov ebx,180*65536+25
    mov ecx,cl_Black
    add edx,modetext
    mov esi,16
    int 0x40

;List size
    outcount [listsize],294,25,cl_Black,4*65536

grad equ 10000000000000000000000000000000b  ;spoke butt

;Draw Scroll Line
    mov eax,13
    mov ebx,350*65536+6
    mov ecx,76*65536+0
    mov esi,[procinfo.y_size]
    sub esi,90
    add ecx,esi
    mov edx,0x00006600
    int 0x40

;Draw Scroll Box
    mov edx,0
    mov eax,[procinfo.y_size]
    sub eax,90
    mov ebx,[listsize]
    inc ebx
    div ebx
;    cmp eax,32
;    ja  no_mul
;    mov ebx,32
;    mul ebx
;no_mul:
    mov edi,eax

    mov esi,[mousey] ;[filecursor]
    shl esi,16

    mov eax,13
    mov ebx,350*65536+6
    mov ecx,76*65536+0
    add ecx,edi
    add ecx,esi
    mov edx,0x00002200
    int 0x40


;Draw button for  button box
    mov ebx,40*65536+300
    mov ecx,76*65536+0
    mov eax,[procinfo.y_size]
    sub eax,90
    add ecx,eax
    mov  eax,8
    mov  edx,4 ;spoke butt
    mov  esi,0x006699aa  ;gradient!!!
    int  0x40


; OUT FILE DATA
    mov eax,[filecursor]           ;calc cursor position
    mov ebx,62
    mul ebx

;OUT TEXT
    mov  ebp,4096 ; 16             ;out strings process
    sub  ebp,[filecursor]
    mov  edx,convinfo ;fileinfo+11
    add  edx,eax
    mov  ebx,50*65536+80
loo:
    mov  ecx,0x00FFFFFF        ;for another file's color white
    cmp  [edx+26],dword 'FOL ' ;folder yellow
    jne  nb
    mov  ecx,0x00FFFF00
    jmp cset1
nb:
    mov eax,[edx+8]

    call colorset
cset1:
    mov  esi,46 ;62 ;32
    mov  eax,4
    pushad
    int  0x40
    popad
    add  ebx,10
noout:
    add  edx,62

    mov eax,ebx           ;if out of window not out text
    shl eax,16
    shr eax,16
    add eax,30
    cmp eax,[procinfo.y_size]
    ja  extloo

    dec  ebp
    jnz  loo
dext:
    mov [downstop],1

extloo:


;Draw text for head->file buttons
    cmp [drawhf],1
    jne  no_drawhftext
    drawfbox 8,35,(6*12)+1,11*8,0x00000000
    drawfbox 9,36,(6*12)-1,(11*8)-2,0x00ffffff

    mov edi,8
    mov ebx,9*65536+37
    mov ecx,cl_Black
    mov edx,file_text_label
    call drawmenu
    jmp no_drawhftext

file_text_label:
    db   '    Open    '
    db   '    Copy    '
    db   '   Paste    '
    db   '   Delete   '
    db   '    View    '
    db   '    Edit    '
    db   '            '
    db   '    Exit    '

no_drawhftext:

;Draw text for head->view buttons
    cmp [drawhv],1
    jne  no_drawhvtext
    drawfbox (8+6*8),35,(6*12)+1,(11*6),0x00000000
    drawfbox (9+6*8),36,(6*12)-1,(11*6)-2,0x00ffffff

    mov edi,6 ;4
    mov ebx,(9+6*8)*65536+37
    mov ecx,cl_Black
    mov edx,view_text_label
    call drawmenu
    jmp no_drawhvtext

view_text_label:
    db   '  Name sort '
    db   '  Ext. sort '
    db   '  Size sort '
    db   '  Date sort '
    db   '  Show DEL  '
    db   '  Fade DEL  '

no_drawhvtext:

;Draw text for head->info buttons
    cmp [drawhi],1
    jne  no_drawhitext
    drawfbox (8+12*8),35,(6*12)+1,(11*2),0x00000000
    drawfbox (9+12*8),36,(6*12)-1,(11*2)-2,0x00ffffff

    mov edi,2
    mov eax,4
    mov ebx,(9+12*8)*65536+37
    mov ecx,cl_Black
    mov edx,info_text_label
    call drawmenu
    jmp no_drawhitext

info_text_label:
    db   '   Help     '
    db   '   About    '

no_drawhitext:

    mov  eax,12                    ; function 12:tell os about windowdraw
    mov  ebx,2                     ; 2, end of draw
    int  0x40

    ret



;   *********************************************
;   *******  WINDOW DEFINITIONS AND DRAW ********
;   ***************  DIALOG  ********************


draw_dialog_window:
    mov  eax,48
    mov  ebx,3
    mov  ecx,sc
    mov  edx,sizeof.system_colors
    int  0x40

    mov  eax,[sc.work_button]
    mov  [b_color],eax

    mov  eax,12                    ; function 12:tell os about windowdraw
    mov  ebx,1                     ; 1, start of draw
    int  0x40

;Window
    xor  eax,eax                   ; function 0 : define and draw window
    mov  ebx,140*65536+320         ; [x start] *65536 + [x size]
    mov  ecx,260*65536+240         ; [y start] *65536 + [y size]
;    mov  edx,[sc.work]             ; color of work area RRGGBB
    or   edx,0x03ffffff;000000
    int  0x40

;Get proc info
    mov eax,9
    mov ebx,procinfo
    mov ecx,-1
    int 0x40

    cmp [clipfile+11],'O'     ;if 11 byte O - is Open dialog
    jne no_openh
    mov edx,head_dlg          ;draw in head OPEN FILE
no_openh:
    cmp [clipfile+11],'S'     ;if 11 byte S - is Save dialog
    jne no_saveh
    mov edx,head_dlg+9        ;draw in head SAVE FILE
no_saveh:
    mov ebx,8*65536+8
    mov ecx,[sc.grab_text]        ; color of text RRGGBB
    or  ecx,0x10000000
    mov esi,9
    mov eax,4
    int 0x40

;Draw buttons instruments
    mov  eax,8
    mov  ebx,16*65536+16+5 ;start pos x
    mov  ecx,29*65536+15   ;start pos y
    mov  edx,8             ;spoke butt
    mov  edi,13            ;draw 13 button's
    mov  esi,cl_Grey
    int  0x40
    dec edi
dnextbut:
    add  ebx,(16+6)*65536
    inc  edx
    int  0x40
    dec  edi
    jnz  dnextbut

;But img
    setimg 16,29,butimg

;Draw OPEN\SAVE button
    mov ebx,0*65536+50
    mov ecx,0*65536+12
    mov eax,[procinfo.x_size]
    sub eax,70
    shl eax,16
    add ebx,eax
    mov eax,[procinfo.y_size]
    sub eax,24
    shl eax,16
    add ecx,eax
    mov  eax,8
    mov  edx,5 ;spoke butt
    mov  esi,0x006699aa  ;gradient!!!
    int  0x40
; label OPEN or SAVE
    mov ebx,[procinfo.x_size]
    sub ebx,56
    mov eax,[procinfo.y_size]
    sub eax,21
    shl ebx,16
    add ebx,eax

    cmp [clipfile+11],'O'     ;if 11 byte O - is Open dialog
    jne no_openb
    mov edx,but_dlg          ;draw in head OPEN FILE
no_openb:
    cmp [clipfile+11],'S'     ;if 11 byte S - is Save dialog
    jne no_saveb
    mov edx,but_dlg+4        ;draw in head SAVE FILE
no_saveb:
    mov ecx,cl_White
    mov esi,4
    mov eax,4
    int 0x40

;Draw URL focus button
    mov ebx,17*65536+0
    mov ecx,0*65536+12
    mov eax,[procinfo.x_size]
    sub eax,90
;    shl eax,16
    add ebx,eax
    mov eax,[procinfo.y_size]
    sub eax,24
    shl eax,16
    add ecx,eax
    mov  eax,8
    mov  edx,2 ;spoke butt
    mov  esi,0x00aaaaaa  ;gradient!!!
    int  0x40

;Draw URL String
    mov eax,[procinfo.x_size]
    sub eax,90
    mov ebp,[procinfo.y_size]
    sub ebp,24
    drawfbox 17,ebp,eax,12,cl_Black ;218
    mov eax,[procinfo.x_size]
    sub eax,92
    mov ebp,[procinfo.y_size]
    sub ebp,23
    drawfbox 18,ebp,eax,10,cl_White

;Draw URL Cursor
    mov eax,6
    mul [cursor]
    mov ebx,eax
    mov eax,19
    add eax,ebx
    mov ebp,[procinfo.y_size]
    sub ebp,22
    drawfbox eax,ebp,1,8,cl_Black ;218

    mov ebx,20*65536
    mov eax,[procinfo.y_size]
    sub eax,22
    add ebx,eax
    mov  eax,4                     ; function 4 : write text to window
    mov  ecx,0x00000000 ;[sc.grab_text] ; color of text RRGGBB
    mov  edx,path                  ; pointer to text beginning
    mov  esi,40 ;12*20             ; text length
    int  0x40

;Out view mode info
    mov eax,[viewmode]
    mov ebx,16
    mul ebx
    mov edx,eax
    mov eax,4
    mov ebx,180*65536+25
    mov ecx,cl_Black
    add edx,modetext
    mov esi,16
;    int 0x40

;List size
;    outcount [listsize],294,25,cl_Black,4*65536


;Draw Scroll Line
    mov eax,13
    mov ebx,296*65536+6
    mov ecx,54*65536+0
    mov esi,[procinfo.y_size]
    sub esi,86
    add ecx,esi
    mov edx,0x00006600
    int 0x40

;Draw Scroll Box
    mov edx,0
    mov eax,[procinfo.y_size]
    sub eax,86 ;90
    mov ebx,[listsize]
    inc ebx
    div ebx
;    cmp eax,32
;    ja  no_mul
;    mov ebx,32
;    mul ebx
;no_mul:
    mov edi,eax

    mov esi,[mousey] ;[filecursor]
    shl esi,16

    mov eax,13
    mov ebx,296*65536+6
    mov ecx,54*65536+0
    add ecx,edi
    add ecx,esi
    mov edx,0x00002200
    int 0x40


;Draw button for  button box
    mov ebx,16*65536+270 ;300
    mov ecx,54*65536+0
    mov eax,[procinfo.y_size]
    sub eax,86 ;90
    add ecx,eax
    mov  eax,8
    mov  edx,4 ;spoke butt
    mov  esi,0x006699aa  ;gradient!!!
    int  0x40

; OUT FILE DATA
    mov eax,[filecursor]           ;calc cursor position
    mov ebx,62
    mul ebx

;OUT TEXT
    mov  ebp,4096 ; 16             ;out strings process
    sub  ebp,[filecursor]
    mov  edx,convinfo ;fileinfo+11
    add  edx,eax
    mov  ebx,19*65536+58  ;80
dloo:
    mov  ecx,0x00FFFFFF        ;for another file's color white
    cmp  [edx+26],dword 'FOL ' ;folder yellow
    jne  dnb
    mov  ecx,0x00FFFF00
    jmp  cset2
dnb:
    mov eax,[edx+8]

    call colorset
cset2:
    mov  esi,46 ;62 ;32
    mov  eax,4
    pushad
    int  0x40
    popad
    add  ebx,10
dnoout:
    add  edx,62

    mov eax,ebx           ;if out of window not out text
    shl eax,16
    shr eax,16
    add eax,40 ;80;30
    cmp eax,[procinfo.y_size]
    ja  dextloo

    dec  ebp
    jnz  dloo
ddext:
    mov [downstop],1

dextloo:

    mov  eax,12                    ; function 12:tell os about windowdraw
    mov  ebx,2                     ; 2, end of draw
    int  0x40

    ret

head_dlg db 'OPEN FILE'
         db 'SAVE FILE'
but_dlg  db 'OPEN'
         db 'SAVE'


colorset:
    cmp  eax,dword '.TXT'  ;text's blue
    je  itx
    cmp  eax,dword '.INC'
    je  itx
    cmp  eax,dword '.ASM'
    je  itx
    jmp nt
itx:
    mov  ecx,0x00AAFFFF
    jmp cset
nt:
    cmp  eax,dword '.BMP'  ;picture's pure
    je  ipic
    cmp  eax,dword '.JPG'
    je  ipic
    jmp np
ipic:
    mov  ecx,0x00FFAAFF
    jmp cset
np:
    cmp  eax,dword '.   '  ;execute's green
    jne  nexec
    mov  ecx,0x0000FF00
    jmp cset
nexec:

cset:
    ret

drawmenu:
    mov eax,4
    mov esi,12
menuloo:
    int 0x40
    add ebx,11
    add edx,12
    dec edi
    jnz menuloo
    ret

menubutton:
    mov  eax,8
nextmenubut:
    int  0x40
    add  ecx,11*65536
    inc  edx
    dec  edi
    jnz  nextmenubut
    ret

read_directory:

    mov  edi,outinfo ;0x14000 ;0x20000
    xor  eax,eax
    mov  ecx,4096*32  ;512
    cld
    rep  stosb

    mov  dword [farea],outinfo
    mov  dword [readblock],0

loorhd:
    mov  eax,[readblock]
    mov  [fileinfoblock+4],eax
    mov  eax,58
    mov  ebx,fileinfoblock
    int  0x40
    cmp  eax,0
    jne  hd_err
    add  dword [farea],512
    inc  dword [readblock]
    cmp  dword [readblock],4096/16
    jna  loorhd

hd_err:
    mov ebx,dword [readblock]
    shl ebx,4
    mov dword [blocksread],ebx ; for quick resorting

    cmp eax,5
    je  end_of_dir

;  It's Test erorr's

    cmp eax,1
    jne no_inv_part
    label 10,10,'Invalid partition or hd base',cl_Red+font_Big
    jmp end_of_dir
no_inv_part:
    cmp eax,3
    jne no_unk_fs
    label 10,10,'Unknow file system',cl_Red+font_Big
    jmp end_of_dir
no_unk_fs:

end_of_dir:
    mov  [dirlen],ebx
    mov  esi,outinfo ;0x14000 ;0x20000
    mov  edi,data_area+1024
    mov  ecx,4096*32 ;512
    cld
    rep  movsb

    mov  ebx,1024

    ; command succesful

    mov  esi,data_area+1024
    mov  edi,fileinfo+11
    mov  edx,4096  ;16

  newlineb:

    pusha               ; clear
    mov  al,32
    mov  ecx,58
    sub  edi,11
    cld
    rep  stosb
    popa

    mov  cl,[esi]       ; end of entries ?
    cmp  cl,6
    jnz  noib0

    mov  [edi+26],dword 'EOE '
    add  esi,32
    add  edi,62
    jmp  inf

  noib0:

    mov  cl,[esi+0]
    cmp  cl,0xe5
    je   yesdelfil

    mov  cl,[esi+11]    ; long fat32 name ?
    cmp  cl,0xf
    jnz  noib1

    mov  [edi+26],dword 'F32 '
    add  esi,32
    add  edi,62
    jmp  inf

  noib1:

    mov  eax,'DAT '     ; data or .. ?

    mov  cl,[esi+0]     ; deleted file
    cmp  cl,0xe5
    je   yesdelfil
    cmp  cl,0x0
    je   yesdelfil
    jmp  nodelfil
   yesdelfil:
    mov  eax,'DEL '
    jmp  ffile
  nodelfil:

    mov  cl,[esi+11]    ; folder
    and  cl,0x10
    jz   ffile
    mov  eax,'FOL '
    mov  [edi+26],eax
    jmp  nosize

  ffile:

    mov  [edi+26],eax

    pusha               ; size
    mov  eax,[esi+28]
    mov  esi,edi
    add  esi,37
    mov  ebx,10
    mov  ecx,8
  newnum:
    xor  edx,edx
    div  ebx
    add  dl,48
    mov  [esi],dl
    test eax,eax
    jz   zernum
    dec  esi
    loop newnum
  zernum:
    popa
  nosize:

    pusha                    ; date
    mov  [edi+17],dword '.  .'

    movzx eax,word [esi+24]
    shr  eax,9         ; year
    add  eax,1980
    mov  ecx,4
  newdel1:
    dec  ecx
    xor  edx,edx
    mov  ebx,10
    div  ebx
    add  edx,48
    mov  [edi+ecx+21],dl
    test ecx,ecx
    jnz  newdel1

    movzx eax,word [esi+24]
    shr  eax,5    ; month
    and  eax,0x0f
    mov  ecx,2
  newdel2:
    dec  ecx
    xor  edx,edx
    mov  ebx,10
    div  ebx
    add  edx,48
    mov  [edi+ecx+18],dl
    test ecx,ecx
    jnz  newdel2

    movzx eax,word [esi+24]
    and  eax,0x1f ; day
    mov  ecx,2
  newdel3:
    dec  ecx
    xor  edx,edx
    mov  ebx,10
    div  ebx
    add  edx,48
    mov  [edi+ecx+15],dl
    test ecx,ecx
    jnz  newdel3

    popa


    pusha                    ; number
    mov  eax,edx
    sub  eax,4096
    neg  eax

    xor  edx,edx
    mov  ebx,10
    div  ebx
    add  dl,48
    mov  [edi+43],dl          ;0001
    xor  edx,edx
    div  ebx
    add  dl,48
    mov  [edi+42],dl          ;0010
    xor  edx,edx
    div  ebx
    add  al,48
    add  dl,48
    mov  [edi+41],dl         ;0100
    mov  [edi+40],byte 0 ;al         ;1000
    popa

    mov  ecx,8          ; first 8
    cld
    rep  movsb
    mov  [edi],byte '.'
    inc  edi
    mov  ecx,3          ; last 3
    cld
    rep  movsb

    add  esi,(32-11)
    add  edi,(60-12+2)

  inf:

    dec  edx
    test edx,edx
    jnz  newlineb

    ret  ; read directory

; ---------_______-------_______ --------_________-----------
; SORT by name and del deletet files or f32 headers from list
; _________-------_______ --------_______---------___________

convertation:
;STEP 1 CLEAR LIST FOR WRITE
    mov esi,convinfo
    mov ecx,4096*62
xxl:
    mov [esi+ecx],byte 255
    dec ecx
    jns xxl

;STEP 2 TEST ON HD OR PARTITION
    cmp [path],byte '/'
    je nstep
    mov ecx,61+62
loxhd:
    mov al,[hdimg+ecx]
    mov [convinfo+ecx],al
    dec ecx
    jns loxhd
    mov [listsize],0
    ret
nstep:
    cmp [path+3],byte '/'
    je nstep2
    mov ecx,61+62
loxpt:
    mov al,[ptimg+ecx]
    mov [convinfo+ecx],al
    dec ecx
    jns loxpt
    mov [listsize],0
    ret
nstep2:

;STEP 3 COPY FILEINFO To CONVINFO
    mov  ebp,0 ; 16             ;out strings process
    mov  edx,fileinfo+11
    mov  esi,convinfo
looo:
;    cmp  [edx],byte 0
;    je   cext

;   Delete del, eoe, f32 and another head-names
    cmp  [viewmode],3  ;0-3 no outdel
    ja   del_out
    cmp  [edx+26],dword 'DEL '
    je   noconv
del_out:
    cmp  [edx+26],dword 'DEL '
    jne  no_del
    cmp  [edx],dword 0 ;431 ;435 ;484 +10% speed
    je   noconv
no_del:
    cmp  [edx+26],dword 'EOE '
    je   noconv
    cmp  [edx+26],dword 'F32 '
    je   noconv
    cmp  [edx],dword '.   '
    je   noconv
    cmp  [edx],dword '..  '
    je   noconv
    cmp  [edx],dword 'FIRS'
    je   noconv

    mov  ecx,61
loox:
    mov al,byte [edx+ecx]
    mov byte [esi+ecx],al
    dec ecx
    jns loox

    add esi,62
noconv:
    add  edx,62
    inc  ebp
    cmp  ebp,4096
    jnae  looo
cext:

;STEP 4 SORT WITH NAME AND FOL OR FILE QUICK!
    mov ecx,4096*62
lox2a:
    mov al,[convinfo+ecx]
    mov [fileinfo+ecx+11],al
    dec ecx
    jns lox2a

    mov ecx,4096*62
lox2b:
    mov [convinfo+ecx],byte 255
    dec ecx
    jns lox2b

    mov eax,[viewmode]
;with no show del files
    cmp eax,0
    je  sort_by_name
    cmp eax,1
    je  sort_by_ext
    cmp eax,2
    je  sort_by_size
    cmp eax,3
    je  sort_by_date
;With Show Del files
    cmp eax,4
    je  sort_by_name
    cmp eax,5
    je  sort_by_ext
    cmp eax,6
    je  sort_by_size
    cmp eax,7
    je  sort_by_date

;SORT BY NAME

sort_by_name:
sort:
    mov ebp,0
    mov edi,0
xxx:
    mov esi,0
    mov ebx,0

ftestname:
    cmp byte [fileinfo+11+26+edi],'F'
    je  F
    cmp byte [fileinfo+11+26+edi],'D'
    je  D
    jmp yyy ;endsort

D:  cmp byte [convinfo+esi+26],'D'
    je D_D
    cmp byte [convinfo+esi+26],'F'
    je D_F
    jmp yyy ;endsort
D_D:
    jmp yyy
D_F:
    jmp skipfile

F:  cmp byte [convinfo+esi+26],'D'
    je F_D
    cmp byte [convinfo+esi+26],'F'
    je F_F
    jmp yyy;endsort
F_D:
    jmp writenow
F_F:
    jmp yyy

yyy:
    mov al,[fileinfo+edi+ebx+11]
    cmp al,[convinfo+esi+ebx]
    je  equal
    jb  writenow
skipfile:
    add esi,62
    mov ebx,0
    jmp ftestname ;yyy

equal:
    inc ebx
    cmp ebx,12
    jae writefile
    jmp yyy

writenow:
    call wrnow

writefile:
    call wrfile

nextfile:
    call showfold

    add edi,62
    inc ebp
    cmp ebp,[blocksread]  ;4096
    jb xxx ;ftestname
    jmp endsort

;SORT BY EXTENSION

sort_by_ext:
sort2:
    mov ebp,0
    mov edi,0
xxx2:
    mov esi,0
    mov ebx,9

ftestname2:
    cmp byte [fileinfo+11+26+edi],'F'
    je  F2
    cmp byte [fileinfo+11+26+edi],'D'
    je  D2
    jmp yyy2 ;endsort

D2:  cmp byte [convinfo+esi+26],'D'
    je D_D2
    cmp byte [convinfo+esi+26],'F'
    je D_F2
    jmp yyy2 ;endsort
D_D2:
    jmp yyy2
D_F2:
    jmp skipfile2

F2:  cmp byte [convinfo+esi+26],'D'
    je F_D2
    cmp byte [convinfo+esi+26],'F'
    je F_F2
    jmp yyy2;endsort
F_D2:
    jmp writenow2
F_F2:
    jmp yyy2

yyy2:
    mov al,[fileinfo+edi+ebx+11]
    cmp al,[convinfo+esi+ebx]
    je  equal2
    jb  writenow2
skipfile2:
    add esi,62
    mov ebx,9  ;0
    jmp ftestname2 ;yyy

equal2:
    inc ebx
    cmp ebx,9
    je  writefile2
    cmp ebx,12
    jae xrw
    jmp yyy2

xrw:
mov ebx,0
    jmp yyy2

writenow2:
    call wrnow

writefile2:
    call wrfile

nextfile2:
    call showfold

    add edi,62
    inc ebp
    cmp ebp,[blocksread]  ;4096
    jb xxx2 ;ftestname
    jmp endsort

;SORT BY SIZE

sort_by_size:
sort3:
    mov ebp,0
    mov edi,0
xxx3:
    mov esi,0
    mov ebx,30

ftestname3:
    cmp byte [fileinfo+11+26+edi],'F'
    je  F3
    cmp byte [fileinfo+11+26+edi],'D'
    je  D3
    jmp yyy3 ;endsort

D3:  cmp byte [convinfo+esi+26],'D'
    je D_D3
    cmp byte [convinfo+esi+26],'F'
    je D_F3
    jmp yyy3 ;endsort
D_D3:
    jmp yyy3
D_F3:
    jmp skipfile3

F3:  cmp byte [convinfo+esi+26],'D'
    je F_D3
    cmp byte [convinfo+esi+26],'F'
    je F_F3
    jmp yyy3;endsort
F_D3:
    jmp writenow3
F_F3:
    jmp yyy3

yyy3:
    mov al,[fileinfo+edi+ebx+11]
    cmp al,[convinfo+esi+ebx]
    je  equal3
    jb  writenow3
skipfile3:
    add esi,62
    mov ebx,30  ;0
    jmp ftestname3 ;yyy

equal3:
    inc ebx
    cmp ebx,12
    je  writefile3
    cmp ebx,38
    jae xrw3
    jmp yyy3

xrw3:
mov ebx,0
    jmp yyy3

writenow3:
    call wrnow

writefile3:
    call wrfile


nextfile3:
    call showfold

    add edi,62
    inc ebp
    cmp ebp,[blocksread]  ;4096
    jb xxx3 ;ftestname
    jmp endsort


;SORT BY DATE

sort_by_date:
sort4:
    mov ebp,0
    mov edi,0
xxx4:
    mov esi,0
    mov ebx,21

ftestname4:
    cmp byte [fileinfo+11+26+edi],'F'
    je  F4
    cmp byte [fileinfo+11+26+edi],'D'
    je  D4
    jmp yyy4 ;endsort

D4:  cmp byte [convinfo+esi+26],'D'
    je D_D4
    cmp byte [convinfo+esi+26],'F'
    je D_F4
    jmp yyy4 ;endsort
D_D4:
    jmp yyy4
D_F4:
    jmp skipfile4

F4:  cmp byte [convinfo+esi+26],'D'
    je F_D4
    cmp byte [convinfo+esi+26],'F'
    je F_F4
    jmp yyy4;endsort
F_D4:
    jmp writenow4
F_F4:
    jmp yyy4

yyy4:
    mov al,[fileinfo+edi+ebx+11]
    cmp al,[convinfo+esi+ebx]
    je  equal4
    jb  writenow4
skipfile4:
    add esi,62
    mov ebx,21  ;0
    jmp ftestname4 ;yyy

equal4:
    inc ebx
    cmp ebx,12
    je  writefile4
    cmp ebx,17
    je  xrw4c
    cmp ebx,20
    je  xrw4b
    cmp ebx,26
    jae xrw4a
    jmp yyy4

xrw4a:
    mov ebx,18
    jmp yyy4

xrw4b:
    mov ebx,15
    jmp yyy4

xrw4c:
    mov ebx,0
    jmp yyy4

writenow4:
    call wrnow

writefile4:
    call wrfile

nextfile4:
    call showfold

    add edi,62
    inc ebp
    cmp ebp,[blocksread]  ;4096
    jb xxx4 ;ftestname
    jmp endsort

;Show num of sorted files
;Clear this proc for add speed
showfold:
    pushad
    dec ebp
    outcount ebp,294,25,cl_White,4*65536
    inc ebp
    outcount ebp,294,25,cl_Black,4*65536
    popad
    ret

;-----------------
wrfile:
    mov ecx,61
wfloop:
    mov al,[fileinfo+ecx+edi+11]
    mov [convinfo+ecx+esi],al
    dec ecx
    jns wfloop
    ret

wrnow:
    mov ecx,4096*62
    sub ecx,esi
ldloop:
    mov al,[convinfo+ecx+esi]
    mov [convinfo+ecx+esi+62],al
    dec ecx
    jns ldloop
    ret

endsort:

;STEP 5 GET SIZE OF RESORTING LIST
    mov ecx,0
    mov edi,0
    mov eax,[blocksread]
    mov ebx,62
    mul ebx
    mov edx,eax
loogs:
    mov eax,dword [convinfo+edi+26]
    cmp eax,dword 0xffffffff
    je endgs
    add edi,62
    inc ecx
    cmp edi,edx ;4096*62
    jnae loogs
endgs:
    mov [listsize],ecx
    ret

;******************************************************************************

; DATA AREA
drawhf     dd 0  ;draw file menu?
drawhv     dd 0  ;draw view menu?
drawhi     dd 0  ;draw info menu?
browser    dd 0  ;0-dialog, 1-browser
cursor     dd 0  ;cursor in prompt line
focus      dd 0  ;prompt edit or window?
;usescroll  dd 0  ;not use avaible
viewmode   dd 0  ;folder sort & not del
downstop   dd 0
filecursor dd 0
mousex     dd 0
mousey     dd 0
blocksread dd 0
listsize   dd 0  ;num of files in directory
temp       dd 0

          ;01234567890123456789012345678901234567890123456789012345678912
hdimg  db 'HD       HARDDISK         FOL                                 '
       db 'RD       RAMDISK          FOL                                 '

ptimg  db '1        FIRST  PARTITION FOL                                 '
       db '2        SECOND PARTITION FOL                                 '

modetext:
      ;0123456789012345
   db 'SORT BY NAME   0'
   db 'SORT BY EXT.   1'
   db 'SORT BY SIZE   2' ;type sort
   db 'SORT BY DATE   3'
   db 'DEL SORT NAME  4'
   db 'DEL SORT EXT.  5'
   db 'DEL SORT SIZE  6' ;type sort
   db 'DEL SORT DATE  7'

dirlen    dd   0x1
b_color   dd   0x6677cc

;Name of programs
editor    db 'TINYPAD    '
bmpview   db 'MV         '
jpgview   db 'JPEGVIEW   '
copyrfile db 'COPYR      '
clipfile  db 'OPENCLIPCLP'
times 256 db 0

fileinfo_start:
dd 16
dd 0
dd 0
dd 0
dd 0x10000
open_path:
times 256 db 0

readblock dd  1

tsoi dd 0

fileinfoblock:
   dd 0x0       ; read
   dd 0x0       ; first block
   dd 0x1       ; number of blocks to read
farea:
   dd outinfo   ; ret offset
   dd 0x4000    ; work size of sytemram
path:
times 256 db 0  ;path

but_file:
file 'systr3.bmp'
rb 60000
tempimg:        ;reserve ram for images
rb 500*16*3+8   ;for picture
butimg:
rb 400*16*3+8   ;buttons (left pice of picture)
logoimg:
rb 70*16*3+8    ;logo (right pice of picture)

rb 2000

sourcepath rb 100
destpath   rb 100

I_END:

paramtest:
rb 256
filedir:
rb 256

procinfo process_information
sc system_colors

fileinfo:
rb 4096*62+1024

outinfo:
rb 4096*34+1024

convinfo:
rb 4096*62+1024

rb 10000

data_area:
