;**************************************************************************
;**********************DECODING BMP FILE(4,8,24 bits)**********************
;***************************************************************************
; FROM ASCL LIBRARY
; BMPTOIMG -Convert BMP format TO IMG format
; (SYNTAX)  BMPTOIMG BMP_source_offset,IMG_dest_ofset
; ( NOTE )  This is macros is not brake bmp structure! Tested in 32,8,4 bits
;***************************************************************************
bmptoimg_data_area_count=0
macro bmptoimg bmp_load_area,img_dest_area
{
local fileinfo,string,end_bmp,nodix
local converttable,noaddelem,nextbit,convert1bpp,convert4bpp,convert2
local nextelem,convertno32,nomorestring,convert1,nextstring,yespicsize
;local qwe,bmpfn

;  convert:
    xor eax,eax
    mov ax,[bmp_load_area+28]
    mul  dword [bmp_load_area+18]
    add  eax,31
    shr  eax,5
    mov  dword [bmptoimg_data_area_dwps],eax  ;dwps-doublewords per string
    shl  eax,2
    mov  dword [bmptoimg_data_area_bps],eax   ;bps-bytes per string

    cmp dword [bmp_load_area+34],0
    jne  yespicsize  ;if picture size is defined
    mul dword [bmp_load_area+22]
    mov dword [bmp_load_area+34],eax

  yespicsize:
    mov ebp,ebx;img_dest_area+8

    mov  eax,bmp_load_area
    mov  ebx,eax
    add  ebx, [bmp_load_area+2];file size
    inc  ebx
    mov  dword [bmptoimg_soi],ebx   ;soi-start of image area for drawing

    add  eax, [bmp_load_area+10]
    mov  dword [bmptoimg_data_area_sop],eax   ;sop-start of picture in file
    add  eax, [bmp_load_area+34]
    mov  dword [bmptoimg_data_area_eop],eax   ;eop-end of picture in file
    mov  eax, [bmp_load_area+18]
    lea  eax,[eax+2*eax]   ;3x pixels in eax

    mov  edi,dword [bmptoimg_soi]   ;initializing
    mov  esi,dword [bmptoimg_data_area_eop]
    sub  esi,dword [bmptoimg_data_area_bps]


  nextstring:
    push edi
    push ebp
    cmp  word [bmp_load_area+28],24
    jne  convertno32

    mov edi,ebp
    mov  ecx,[bmptoimg_data_area_dwps]
    cld
    rep movsd

  convert1:
    pop  ebp
    pop  edi
    sub  esi,dword [bmptoimg_data_area_bps]
    sub  esi,dword [bmptoimg_data_area_bps]
    cmp  esi,dword [bmptoimg_data_area_sop]
    jle   end_bmp  ;zaplatka ot 05.01.06 vmesto jl, jle
		   ;ot 15.10.2004 vmesto jb
    add  edi,eax
    add  ebp,eax
    jmp  nextstring

  convertno32:
    mov  ebx,bmp_load_area
    add  ebx, [bmp_load_area+14]
    add  ebx,14 	 ;start of color table
    push esi
    add  esi,dword [bmptoimg_data_area_bps]
    mov  dword [bmptoimg_data_area_eos],esi
    pop  esi
  nextelem:
    push eax
    xor eax,eax
    mov al,byte [esi]
    cmp  word [bmp_load_area+28],4
    je	 convert4bpp
    cmp  word [bmp_load_area+28],1
    je	 convert1bpp
    call converttable

  convert2:
    pop  eax
    inc  esi
    cmp  esi,dword [bmptoimg_data_area_eos]
    jae  convert1
    add  edi,3
    add  ebp,3
    jmp  nextelem

  convert4bpp:
    shl  ax,4
    shr  al,4
    push eax

    and eax,0xffff
    shr eax,8
    ;movzx eax,ah
    call converttable
    ;add  edi,3

    add ebp,3

    pop  eax

    movzx eax,al
    call converttable
    jmp  convert2

  convert1bpp:
    mov  ecx,eax
    mov  edx,7
  nextbit:
    xor  eax,eax
    bt	 ecx,edx
    jnc  noaddelem
    inc  eax
  noaddelem:
    push edx
    call converttable
    pop  edx
    dec  edx
    js	 convert2
    add  edi,3

    add  ebp,3

    jmp  nextbit

  converttable:
    shl  eax,2
    add  eax,ebx
    mov  edx, dword [eax]
    mov [ebp],dx
    shr edx,16
    mov [ebp+2],dl
    ret

bmptoimg_data_area_count=bmptoimg_data_area_count+1
if bmptoimg_data_area_count = 1
; DATA AREA
bmptoimg_soi		    dd 0
bmptoimg_data_area_bps	    dd 0
bmptoimg_data_area_dwps     dd 0
bmptoimg_data_area_sop	    dd 0
bmptoimg_data_area_eop	    dd 0
bmptoimg_data_area_eos	    dd 0
end if

end_bmp:
}

;***************************************************************************
;*******************CODING BMP FILE(4,8,24 bits)****************************
;***************************************************************************
;*************************andrew_programmer*********************************
coding_bmp:

	 mov [PointerToImage],ebx
	 mov [WhereCodingBMP],ecx
	 mov [BmpPalette],edx
	 mov [Bmp_SizeX],esi
	 mov [Bmp_SizeY],edi
	 ;**************16 colors BMP*******************
	 cmp eax,16
	 ja no_16_colors
	 ;copy 16 colors palette
	 mov esi,[BmpPalette]
	 mov edi,[WhereCodingBMP]
	 add edi,54
	 mov ecx,16
	 rep movsd

	 ;coding image to bmp 4 bits format
	 mov esi,[PointerToImage]
	 mov edx,[WhereCodingBMP]
	 mov ebx,[Bmp_SizeX]
	 mov ecx,[Bmp_SizeY]
	 dec ecx
	 inc ebx
	 shr ebx,1
	 imul ebx,ecx
	 add edx,54+64
	 add edx,ebx
	 mov ebp,[Bmp_SizeX]
	 mov ebx,[Bmp_SizeY]
	 inc ebp
	 shr ebp,1

	 mov [Bmp_Counter2],ebx
	 xor ebx,ebx
	 copy_lines_4:
	 mov ecx,[Bmp_SizeX]
	 mov edi,edx
	 shr ecx,1
	 shl ecx,1
	 and [Bmp_Counter3],0
	  rep_movsb_4:
	  mov eax,[esi]
	  and eax,0xffffff
	  push esi
	  push ecx
	  push ebx
	   mov esi,[BmpPalette]
	   xor ecx,ecx
	    find_color_in_palette_:
	    mov ebx,[esi]
	    and ebx,0xffffff
	    cmp eax,ebx 	  ;color fined ?
	    je color_fined_
	    add esi,4
	    inc ecx
	    cmp ecx,16
	    jl find_color_in_palette_
	    color_fined_:
	    mov [Bmp_Counter],ecx     ;number color in palette
	  pop ebx
	  pop ecx
	  pop esi
	  xor eax,eax
	  mov eax,[Bmp_Counter]
	  shl bl,4
	  add bl,al
	   push ecx
	   mov ecx,[Bmp_Counter3]
	   and ecx,1b
	   test ecx,ecx 	     ;next block ready ?
	   jz no_ready
	   mov [edi],bl 	     ;4 bit color
	   inc edi
	   no_ready:
	   pop ecx
	  add esi,3
	  inc [Bmp_Counter3]
	  dec ecx
	  jnz rep_movsb_4
	  ;--------------
	   mov ecx,[Bmp_Counter3]
	   and ecx,1b
	   test ecx,ecx 	     ;next block ready ?
	   jz no_ready_
	   shl bl,4
	   mov [edi],bl 	     ;4 bit color
	   no_ready_:
	  ;--------------
	 sub edx,ebp
	 dec [Bmp_Counter2]
	 jnz copy_lines_4
	 ;crate list of bmp description
	 mov edi,[WhereCodingBMP]
	 mov ebx,[Bmp_SizeX]
	 inc ebx
	 shr ebx,1
	 imul ebx,[Bmp_SizeY]
	 add ebx,54+64
	 mov [edi],word 'BM'
	 mov [edi+2],ebx
	 mov [edi+10],dword 54+64
	 mov [edi+14],dword 40
	 mov edx,[Bmp_SizeX]
	 mov ecx,[Bmp_SizeY]
	 mov [edi+18],edx
	 mov [edi+22],ecx
	 mov [edi+26],word 1
	 mov [edi+28],word 4
	 mov [edi+30],dword 0
	 inc edx
	 shr edx,1
	 imul edx,ecx
	 mov [edi+34],edx
	 mov [edi+38],dword 0
	 mov [edi+42],dword 0
	 mov [edi+46],dword 0

	 ret
	 no_16_colors:

	 ;**************256 colors BMP******************
	 cmp eax,256
	 ja no_8_bits_per_pixel
	 ;copy palette
	 mov esi,[BmpPalette]
	 mov edi,[WhereCodingBMP]
	 add edi,54
	 mov ecx,256
	 rep movsd

	 ;coding image to bmp 8 bits format
	 mov esi,[PointerToImage]
	 mov edx,[WhereCodingBMP]
	 mov ebx,[Bmp_SizeX]
	 mov ecx,[Bmp_SizeY]
	 dec ecx
	 imul ebx,ecx
	 add edx,1078
	 add edx,ebx
	 mov ebp,[Bmp_SizeX]
	 mov ebx,[Bmp_SizeY]

	 mov [Bmp_Counter2],ebx
	 copy_lines_8:
	 mov ecx,[Bmp_SizeX]
	 mov edi,edx
	  rep_movsb_8:
	  mov eax,[esi]
	  and eax,0xffffff
	  push esi
	  push ecx
	  push ebx
	   mov esi,[BmpPalette]
	   xor ecx,ecx
	    find_color_in_palette:
	    mov ebx,[esi]
	    and ebx,0xffffff
	    cmp eax,ebx 	  ;color fined ?
	    je color_fined
	    add esi,4
	    inc ecx
	    cmp ecx,256
	    jl find_color_in_palette
	    color_fined:
	    mov [Bmp_Counter],ecx     ;number color in palette
	  pop ebx
	  pop ecx
	  pop esi
	  mov eax,[Bmp_Counter]
	  mov [edi],al		  ;8 bit color
	  add esi,3
	  inc edi
	  dec ecx
	  jnz rep_movsb_8
	 sub edx,ebp
	 dec [Bmp_Counter2]
	 jnz copy_lines_8
	 ;crate list of bmp description
	 mov edi,[WhereCodingBMP]
	 mov ebx,[Bmp_SizeX]
	 imul ebx,[Bmp_SizeY]
	 add ebx,54+1024
	 mov [edi],word 'BM'
	 mov [edi+2],ebx
	 mov [edi+10],dword 54+1024
	 mov [edi+14],dword 40
	 mov edx,[Bmp_SizeX]
	 mov ecx,[Bmp_SizeY]
	 mov [edi+18],edx
	 mov [edi+22],ecx
	 mov [edi+26],word 1
	 mov [edi+28],word 8
	 mov [edi+30],dword 0
	 imul edx,ecx
	 mov [edi+34],edx
	 mov [edi+38],dword 0
	 mov [edi+42],dword 0
	 mov [edi+46],dword 0

	 ret
	 no_8_bits_per_pixel:

	 ;********************24 bit BMP****************
	 cmp eax,256
	 jle no_32_bits_per_pixel
	 ;copy picture
	 mov esi,[PointerToImage]
	 mov edx,[WhereCodingBMP]
	 mov ebx,[Bmp_SizeX]
	 mov ecx,[Bmp_SizeY]
	 dec ecx
	 imul ebx,ecx
	 lea ebx,[ebx+ebx*2]
	 add edx,1078
	 add edx,ebx
	 mov ebp,[Bmp_SizeX]
	 lea ebp,[ebp+ebp*2]
	 mov ebx,[Bmp_SizeY]

	 copy_lines_32:
	 mov ecx,[Bmp_SizeX]
	 lea ecx,[ecx+ecx*2]
	 mov edi,edx
	 rep movsb
	 sub edx,ebp
	 dec ebx
	 jnz copy_lines_32

	 mov edi,[WhereCodingBMP]
	 add edi,1078-54
	 mov ebx,[Bmp_SizeX]
	 imul ebx,[Bmp_SizeY]
	 lea ebx,[ebx+ebx*2]
	 add ebx,54
	 mov [edi],word 'BM'
	 mov [edi+2],ebx
	 mov [edi+10],dword 54
	 mov [edi+14],dword 40
	 mov edx,[Bmp_SizeX]
	 mov ecx,[Bmp_SizeY]
	 mov [edi+18],edx
	 mov [edi+22],ecx
	 mov [edi+26],word 1
	 mov [edi+28],word 24
	 mov [edi+30],dword 0
	 imul edx,ecx
	 lea edx,[edx+edx*2]
	 mov [edi+34],edx
	 mov [edi+38],dword 0
	 mov [edi+42],dword 0
	 mov [edi+46],dword 0
	 ret
	 no_32_bits_per_pixel:


	 ret

PointerToImage	     dd 0
WhereCodingBMP	     dd 0
BmpPalette	     dd 0
Bmp_SizeX	     dd 0
Bmp_SizeY	     dd 0
Bmp_Counter	     dd 0
Bmp_Counter2	     dd 0
Bmp_Counter3	     dd 0